package be.iminds.ilabt.jfed.restapi.dropwizard;

import ch.qos.logback.classic.LoggerContext;
import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.Appender;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.dropwizard.logging.AbstractAppenderFactory;
import io.dropwizard.logging.async.AsyncAppenderFactory;
import io.dropwizard.logging.filter.LevelFilterFactory;
import io.dropwizard.logging.layout.LayoutFactory;

/**
 * JFedRestApiDebugDataAppenderFactory provides access to all slf4j logging messages
 *
 * This needs to be registered in the file "META-INFI/services/io.dropwizard.logging.AppenderFactory"
 */
@JsonTypeName("jFedRestApiDebugData")
public class JFedRestApiDebugDataAppenderFactory extends AbstractAppenderFactory {
    private JFedLoggingAppender singleAppender = null;

    public JFedLoggingAppender getAppender() {
        return singleAppender;
    }

    @Override
    public Appender<ILoggingEvent> build(LoggerContext loggerContext, String s, LayoutFactory layoutFactory, LevelFilterFactory levelFilterFactory, AsyncAppenderFactory asyncAppenderFactory) {
        JFedLoggingAppender appender;
        if (singleAppender == null) {
            appender = new JFedLoggingAppender();
            singleAppender = appender;
        } else {
            appender = singleAppender;
        }

        appender.setName("jfed-all");
        appender.setContext(loggerContext);

        appender.start();

        return wrapAsync(appender, asyncAppenderFactory);
    }
}
